source: src-sh/pc-extractoverlay/ports-overlay/usr/local/sbin/grub-mkconfig

Last change on this file was 0fbe5d0, checked in by Kris Moore <kris@…>, 7 weeks ago

Update grub overlay data to match current 2.02 pre-release version we just pushed to
ports tree

  • Property mode set to 100755
File size: 7.9 KB
Line 
1#! /bin/sh
2set -e
3
4# Generate grub.cfg by inspecting /boot contents.
5# Copyright (C) 2006,2007,2008,2009,2010 Free Software Foundation, Inc.
6#
7# GRUB is free software: you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation, either version 3 of the License, or
10# (at your option) any later version.
11#
12# GRUB is distributed in the hope that it will be useful,
13# but WITHOUT ANY WARRANTY; without even the implied warranty of
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15# GNU General Public License for more details.
16#
17# You should have received a copy of the GNU General Public License
18# along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
19
20prefix="/usr/local"
21exec_prefix="/usr/local"
22datarootdir="/usr/local/share"
23
24prefix="/usr/local"
25exec_prefix="/usr/local"
26sbindir="${exec_prefix}/sbin"
27bindir="${exec_prefix}/bin"
28sysconfdir="${prefix}/etc"
29PACKAGE_NAME=GRUB
30PACKAGE_VERSION=2.02~beta2
31host_os=freebsd10.0
32datadir="${datarootdir}"
33if [ "x$pkgdatadir" = x ]; then
34    pkgdatadir="${datadir}/grub"
35fi
36grub_cfg=""
37grub_mkconfig_dir="${sysconfdir}"/grub.d
38
39self=`basename $0`
40
41grub_probe="${sbindir}/grub-probe"
42grub_file="${bindir}/grub-file"
43grub_editenv="${bindir}/grub-editenv"
44grub_script_check="${bindir}/grub-script-check"
45
46export TEXTDOMAIN=grub
47export TEXTDOMAINDIR="/usr/local/share/locale"
48
49. "${pkgdatadir}/grub-mkconfig_lib"
50
51# Usage: usage
52# Print the usage.
53usage () {
54    gettext_printf "Usage: %s [OPTION]\n" "$self"
55    gettext "Generate a grub config file"; echo
56    echo
57    print_option_help "-o, --output=$(gettext FILE)" "$(gettext "output generated config to FILE [default=stdout]")"
58    print_option_help "-h, --help" "$(gettext "print this message and exit")"
59    print_option_help "-v, --version" "$(gettext "print the version information and exit")"
60    echo
61    gettext "Report bugs to <bug-grub@gnu.org>."; echo
62}
63
64argument () {
65  opt=$1
66  shift
67
68  if test $# -eq 0; then
69      gettext_printf "%s: option requires an argument -- \`%s'\n" "$self" "$opt" 1>&2
70      exit 1
71  fi
72  echo $1
73}
74
75# Check the arguments.
76while test $# -gt 0
77do
78    option=$1
79    shift
80
81    case "$option" in
82    -h | --help)
83        usage
84        exit 0 ;;
85    -v | --version)
86        echo "$self (${PACKAGE_NAME}) ${PACKAGE_VERSION}"
87        exit 0 ;;
88    -o | --output)
89        grub_cfg=`argument $option "$@"`; shift;;
90    --output=*)
91        grub_cfg=`echo "$option" | sed 's/--output=//'`
92        ;;
93    -*)
94        gettext_printf "Unrecognized option \`%s'\n" "$option" 1>&2
95        usage
96        exit 1
97        ;;
98    # Explicitly ignore non-option arguments, for compatibility.
99    esac
100done
101
102if [ "x$EUID" = "x" ] ; then
103  EUID=`id -u`
104fi
105
106if [ "$EUID" != 0 ] ; then
107  root=f
108  case "`uname 2>/dev/null`" in
109    CYGWIN*)
110      # Cygwin: Assume root if member of admin group
111      for g in `id -G 2>/dev/null` ; do
112        case $g in
113          0|544) root=t ;;
114        esac
115      done ;;
116  esac
117  if [ $root != t ] ; then
118    gettext_printf "%s: You must run this as root\n" "$self" >&2
119    exit 1
120  fi
121fi
122
123set $grub_probe dummy
124if test -f "$1"; then
125    :
126else
127    gettext_print "%s: Not found.\n" "$1" 1>&2
128    exit 1
129fi
130
131# Device containing our userland.  Typically used for root= parameter.
132GRUB_DEVICE="`${grub_probe} --target=device /`"
133GRUB_DEVICE_UUID="`${grub_probe} --device ${GRUB_DEVICE} --target=fs_uuid 2> /dev/null`" || true
134
135# Device containing our /boot partition.  Usually the same as GRUB_DEVICE.
136GRUB_DEVICE_BOOT="`${grub_probe} --target=device /boot`"
137GRUB_DEVICE_BOOT_UUID="`${grub_probe} --device ${GRUB_DEVICE_BOOT} --target=fs_uuid 2> /dev/null`" || true
138
139# Filesystem for the device containing our userland.  Used for stuff like
140# choosing Hurd filesystem module.
141GRUB_FS="`${grub_probe} --device ${GRUB_DEVICE} --target=fs 2> /dev/null || echo unknown`"
142
143if [ x"$GRUB_FS" = xunknown ]; then
144    GRUB_FS="$(stat -f --printf=%T / || echo unknown)"
145fi
146
147if test -f ${sysconfdir}/default/grub ; then
148  . ${sysconfdir}/default/grub
149fi
150
151# XXX: should this be deprecated at some point?
152if [ "x${GRUB_TERMINAL}" != "x" ] ; then
153  GRUB_TERMINAL_INPUT="${GRUB_TERMINAL}"
154  GRUB_TERMINAL_OUTPUT="${GRUB_TERMINAL}"
155fi
156
157termoutdefault=0
158if [ "x${GRUB_TERMINAL_OUTPUT}" = "x" ]; then
159    GRUB_TERMINAL_OUTPUT=gfxterm;
160    termoutdefault=1;
161fi
162
163for x in ${GRUB_TERMINAL_OUTPUT}; do
164    case "x${x}" in
165        xgfxterm) ;;
166        xconsole | xserial | xofconsole | xvga_text)
167            # make sure all our children behave in conformance with ascii..
168            export LANG=C;;
169        *) echo "Invalid output terminal \"${GRUB_TERMINAL_OUTPUT}\"" >&2 ; exit 1 ;;
170    esac
171done
172
173GRUB_ACTUAL_DEFAULT="$GRUB_DEFAULT"
174
175if [ "x${GRUB_ACTUAL_DEFAULT}" = "xsaved" ] ; then GRUB_ACTUAL_DEFAULT="`"${grub_editenv}" - list | sed -n '/^saved_entry=/ s,^saved_entry=,,p'`" ; fi
176
177
178# These are defined in this script, export them here so that user can
179# override them.
180export GRUB_DEVICE \
181  GRUB_DEVICE_UUID \
182  GRUB_DEVICE_BOOT \
183  GRUB_DEVICE_BOOT_UUID \
184  GRUB_FS \
185  GRUB_FONT \
186  GRUB_PRELOAD_MODULES \
187  GRUB_ACTUAL_DEFAULT
188
189# These are optional, user-defined variables.
190export GRUB_DEFAULT \
191  GRUB_HIDDEN_TIMEOUT \
192  GRUB_HIDDEN_TIMEOUT_QUIET \
193  GRUB_TIMEOUT \
194  GRUB_TIMEOUT_STYLE \
195  GRUB_DEFAULT_BUTTON \
196  GRUB_HIDDEN_TIMEOUT_BUTTON \
197  GRUB_TIMEOUT_BUTTON \
198  GRUB_TIMEOUT_STYLE_BUTTON \
199  GRUB_BUTTON_CMOS_ADDRESS \
200  GRUB_BUTTON_CMOS_CLEAN \
201  GRUB_DISTRIBUTOR \
202  GRUB_CMDLINE_LINUX \
203  GRUB_CMDLINE_LINUX_DEFAULT \
204  GRUB_CMDLINE_XEN \
205  GRUB_CMDLINE_XEN_DEFAULT \
206  GRUB_CMDLINE_LINUX_XEN_REPLACE \
207  GRUB_CMDLINE_LINUX_XEN_REPLACE_DEFAULT \
208  GRUB_CMDLINE_NETBSD \
209  GRUB_CMDLINE_NETBSD_DEFAULT \
210  GRUB_CMDLINE_GNUMACH \
211  GRUB_TERMINAL_INPUT \
212  GRUB_TERMINAL_OUTPUT \
213  GRUB_SERIAL_COMMAND \
214  GRUB_DISABLE_LINUX_UUID \
215  GRUB_DISABLE_RECOVERY \
216  GRUB_VIDEO_BACKEND \
217  GRUB_GFXMODE \
218  GRUB_BACKGROUND \
219  GRUB_THEME \
220  GRUB_GFXPAYLOAD_LINUX \
221  GRUB_DISABLE_OS_PROBER \
222  GRUB_INIT_TUNE \
223  GRUB_SAVEDEFAULT \
224  GRUB_ENABLE_CRYPTODISK \
225  GRUB_BADRAM \
226  GRUB_OS_PROBER_SKIP_LIST \
227  GRUB_DISABLE_SUBMENU
228
229if test "x${grub_cfg}" != "x"; then
230  rm -f "${grub_cfg}.new"
231  oldumask=$(umask); umask 077
232  exec > "${grub_cfg}.new"
233  umask $oldumask
234fi
235gettext "Generating grub configuration file ..." >&2
236echo >&2
237
238cat << EOF
239#
240# DO NOT EDIT THIS FILE
241#
242# It is automatically generated by $self using templates
243# from ${grub_mkconfig_dir} and settings from ${sysconfdir}/default/grub
244#
245EOF
246
247
248for i in "${grub_mkconfig_dir}"/* ; do
249  case "$i" in
250    # emacsen backup files. FIXME: support other editors
251    *~) ;;
252    # emacsen autosave files. FIXME: support other editors
253    */\#*\#) ;;
254    *)
255      if grub_file_is_not_garbage "$i" && test -x "$i" ; then
256        echo
257        echo "### BEGIN $i ###"
258        "$i"
259        echo "### END $i ###"
260      fi
261    ;;
262  esac
263done
264
265if test "x${grub_cfg}" != "x" ; then
266  if ! ${grub_script_check} ${grub_cfg}.new; then
267    # TRANSLATORS: %s is replaced by filename
268    gettext_printf "Syntax errors are detected in generated GRUB config file.
269Ensure that there are no errors in /etc/default/grub
270and /etc/grub.d/* files or please file a bug report with
271%s file attached." "${grub_cfg}.new" >&2
272    echo >&2
273  else
274    # none of the children aborted with error, install the new grub.cfg
275    mv -f ${grub_cfg}.new ${grub_cfg}
276  fi
277fi
278
279# KPM 6-24-2013
280# If doing a real grub.cfg update, make sure that our config gets
281# copied to the /default/ ZFS BE
282check_grub_zfs_be()
283{
284  if [ "$grub_cfg" = "/boot/grub/grub.cfg" ] ; then
285    dTank=`beadm list -a 2>/dev/null | grep '/ROOT/default' | awk '{print $1}'`
286    if ! mount | grep -q "$dTank on / ("; then
287       echo -e "Copying grub.cfg to $dTank...\c" >&2
288       fMnt="/mnt.$$"
289       mkdir $fMnt
290       if ! mount -t zfs ${dTank} $fMnt ; then
291          echo "Failed to mount ${dTank}" >&2
292          return
293       else
294         cp ${grub_cfg} ${fMnt}/boot/grub/grub.cfg
295         echo -e "done" >&2
296         umount ${fMnt} >/dev/null
297         rmdir ${fMnt} >/dev/null
298       fi
299    fi
300  fi
301
302}
303gettext "done" >&2
304echo >&2
305
306# Check if we need to copy this cfg to the original BE
307check_grub_zfs_be
308
Note: See TracBrowser for help on using the repository browser.